
/* Player (C) Double Shadow */
/* Bartovic Milan 	bartovic@elf.stuba.sk */
/* V Bratislave dna 2.5.1995 */

//#include <stdio.h>

zisti_prioritu(int start_x,int  start_y,int  end);
void posun(int hore,int vpravo,int *mozne_y,int *mozne_x,int *priorita,int start_y,int start_x,int end);
int maximum(int *p,int pocet);
int minimum(int *p,int pocet);
void bufruj(int y,int x,int  akcia,int  end);
void analyza (int riadok,int stlpec,int *vystup_y,int *vystup_x);

#define HODNOTA 3
#define BLOK 2

#define XMAX 19
#define XMIN 1
#define YMAX 19
#define YMIN 1

#define OK 100
#define KO 200
#define WALL 255

int pole[21][21];
int priority_o[8];
int adresy_o[8][2];
int priority_u[8];
int adresy_u[8][2];

int bufer_klaves[10][2];
int poloha_do_bufra=0;

int vyhra;
int tri_o;
int styri_o;
int tri_u;


/* vrati prioritu tahu na pole mozne_y,x */
void posun(int hore,int vpravo,int *mozne_y,int *mozne_x,int *priorita,int start_y,int start_x,int end)

{ int cislo,p_c;
  int p_y,p_x;
  while ( pole[start_y][start_x] == end )
	{ start_y = start_y + hore;
	  start_x = start_x + vpravo;		/* posun v smere hore
						+ vpravo na volnu
						poziciu */
	}
  *mozne_y=start_y;
  *mozne_x=start_x;

  if ( pole[start_y][start_x] != 0 )
	{ *priorita = 0;
	  return;
	}

  *priorita = zisti_prioritu(start_x, start_y, end);
  return;
}

/* vstup volne policko - vystup priorita vzhladom na end (KO - OK) */
zisti_prioritu(int start_x,int  start_y,int  end)

{ int p_c;
  int cislo;
  int p_x,p_y;

/* takze na start_y,x je prazdne pole */
  cislo=0;

/* y=1, x=1 */
  p_c = 0;
  p_y = start_y + 1;
  p_x = start_x + 1;
  if ( pole[p_y][p_x] == end )
	{ p_c = 1;
	  p_y += 1;
	  p_x += 1;
	  while ( pole[p_y][p_x] == end )
		{ p_c *= HODNOTA;
		  p_y += 1;
		  p_x += 1;
		}
	  if ( pole[p_y][p_x] == 0 )
			p_c *= HODNOTA;
		else
			p_c *= BLOK;
	}

/* y=-1, x=-1 */
  p_y = start_y - 1;
  p_x = start_x - 1;
  if ( pole[p_y][p_x] == end)
	{ if (p_c == 0) p_c = 1;
	  p_x -= 1;
	  p_y -= 1;
	  while ( pole[p_y][p_x] == end )
		{ p_c *= HODNOTA;
		  p_y -= 1;
		  p_x -= 1;
		}
	  if ( pole[p_y][p_x] == 0 )
			p_c *= HODNOTA;
		else
			p_c *= BLOK;
	}
  cislo += p_c;

  if (p_c >= 27) tri_u=1;
  if (p_c >= 54) vyhra=1;

/* y=1, x=-1 */
  p_c = 0;
  p_y = start_y + 1;
  p_x = start_x - 1;
  if ( pole[p_y][p_x] == end )
	{ p_c = 1;
	  p_y += 1;
	  p_x -= 1;
	  while ( pole[p_y][p_x] == end )
		{ p_c *= HODNOTA;
		  p_y += 1;
		  p_x -= 1;
		}
	  if ( pole[p_y][p_x] == 0 )
			p_c *= HODNOTA;
		else
			p_c *= BLOK;
	}

/* y=-1, x=1 */
  p_y = start_y - 1;
  p_x = start_x + 1;
  if ( pole[p_y][p_x] == end )
	{ if (p_c == 0) p_c = 1;
	  p_y -= 1;
	  p_x += 1;
	  while ( pole[p_y][p_x] == end )
		{ p_c *= HODNOTA;
		  p_y -= 1;
		  p_x += 1;
		}
	  if ( pole[p_y][p_x] == 0 )
			p_c *= HODNOTA;
		else
			p_c *= BLOK;
	}
  cislo += p_c;

  if (p_c >= 27) tri_u=1;
  if (p_c >= 54) vyhra=1;



/* y=0, x=1 */
  p_c = 0;
  p_x = start_x + 1;
  p_y = start_y;
  if ( pole[p_y][p_x] == end )
	{ p_c = 1;
	  p_x += 1;
	  while ( pole[p_y][p_x] == end )
		{ p_c *= HODNOTA;
		  p_x += 1;
		}
	  if ( pole[p_y][p_x] == 0 )
			p_c *= HODNOTA;	/* moze tu byt: else
						   p_c *= BLOK; */
		else
			p_c *= BLOK;
	}

/* y=0, x=-1 */
  p_x = start_x - 1;
  p_y = start_y;
  if ( pole[p_y][p_x] == end )
	{ if (p_c == 0) p_c = 1;
	  p_x -= 1;
	  while ( pole[p_y][p_x] == end )
		{ p_c *= HODNOTA;
		  p_x -= 1;
		}
	  if ( pole[p_y][p_x] == 0 )
			p_c *= HODNOTA;
		else
			p_c *= BLOK;
	}
  cislo += p_c;

  if (p_c >= 27) tri_u=1;
  if (p_c >= 54) vyhra=1;

/* y=1, x=0 */
  p_c = 0;
  p_y = start_y + 1;
  p_x = start_x;
  if ( pole[p_y][p_x] == end )
	{ p_c = 1;
	  p_y += 1;
	  while ( pole[p_y][p_x] == end )
		{ p_c *= HODNOTA;
		  p_y += 1;
		}
	  if ( pole[p_y][p_x] == 0 )
			p_c *= HODNOTA;
		else
			p_c *= BLOK;
	}

/* y=-1, x=0 */
  p_y = start_y - 1;
  p_x = start_x;
  if ( pole[p_y][p_x] == end )
	{ if (p_c == 0) p_c = 1;
	  p_y -= 1;
	  while ( pole[p_y][p_x] == end )
		{ p_c *= HODNOTA;
		  p_y -= 1;
		}
	  if ( pole[p_y][p_x] == 0 )
			p_c *= HODNOTA;
		else
			p_c *= BLOK;
	}
  cislo += p_c;

  if (p_c >= 27) tri_u=1;
  if (p_c >= 54) vyhra=1;


  return(cislo);

}

int maximum(int *p,int pocet)
{ int i,j=0;
  for (i=1; i<pocet; i++)
	if (p[i] > p[j])
		j=i;
  return(j);
}

int minimum(int *p,int pocet)
{ int i,j=0;
  for (i=1; i<pocet; i++)
	if (p[i] < p[j])
		j=i;
  return(j);
}


/* vrati bufrovane najLEPSIE TAHY  1 - obrana ine - utok */
void bufruj(int y,int x,int  akcia,int  end)
{
  int priorita[8];
  int mozne_y[8];
  int mozne_x[8];
  int i,j,k,max;

/* posun vo vsetkych smeroch */
  posun(0, 1, &mozne_y[0], &mozne_x[0], &priorita[0], y, x, end);
  posun(1, 1, &mozne_y[1], &mozne_x[1], &priorita[1], y, x, end);
  posun(1, 0, &mozne_y[2], &mozne_x[2], &priorita[2], y, x, end);
  posun(1, -1, &mozne_y[3], &mozne_x[3], &priorita[3], y, x, end);
  posun(0, -1, &mozne_y[4], &mozne_x[4], &priorita[4], y, x, end);
  posun(-1, -1, &mozne_y[5], &mozne_x[5], &priorita[5], y, x, end);
  posun(-1, 0, &mozne_y[6], &mozne_x[6], &priorita[6], y, x, end);
  posun(-1, 1, &mozne_y[7], &mozne_x[7], &priorita[7], y, x, end);

 if ( akcia == 1)
	 for (i=0; i<3; i++)
	      { j=maximum(priorita, 8);
	  	k=minimum(priority_o, 8);
	  	if ( priorita[j] > priority_o[k] )
			{ priority_o[k] = priorita[j];
			  adresy_o[k][0] = mozne_y[j];
			  adresy_o[k][1] = mozne_x[j];
			}
		priorita[j]=0;
	      }
	else
	  for (i=0; i<3; i++)
		{ j=maximum(priorita, 8);	
		  k=minimum(priority_u, 8);
		  if ( priorita[j] > priority_u[k] )
			{ priority_u[k] = priorita[j];
			  adresy_u[k][0] = mozne_y[j];
			  adresy_u[k][1] = mozne_x[j];
			}
		  priorita[j]=0;
		}
}


void analyza (int riadok,int stlpec,int *vystup_y,int *vystup_x)
{ int end;
  int i,j;
  int obrana,utok;

  end = KO;
  bufruj(riadok, stlpec, 1, end);	/* najlepsie obranne tahy */
				/* priority_o + adresy_o */
/* protivnik */
  styri_o=vyhra;		/* ak 1 - 4 v jednom smere */
  tri_o=tri_u;

/* teraz pojde o moju situaciu */
  vyhra=0;
  tri_u=0;


  end = OK;
  for (i=0; i<10; i++)
  	{ riadok = bufer_klaves[i][0];
	  stlpec = bufer_klaves[i][1];
	  if (stlpec == 0 || riadok == 0) continue;	
	  bufruj(riadok, stlpec, 0, end);
						/* najlepsie utocne tahy */
  					/* priority_u + adresy_u */
	}	  

  i=maximum(priority_o, 8);
  j=maximum(priority_u, 8);

  obrana=priority_o[i];
  utok=priority_u[j];

  if (utok == 0) obrana=100;
  if (vyhra == 1) utok=110;
  if (tri_u == 1 && styri_o == 0) utok=110;
  if (utok == 110) 
		{ *vystup_y=adresy_u[j][0];
		  *vystup_x=adresy_u[j][1];
		  priority_u[j]=0;
		  return;
		}
  if (obrana > 17)
		{ *vystup_y=adresy_o[i][0];	/* obrana */
		  *vystup_x=adresy_o[i][1];
		  priority_o[i]=0;
  	  	  return;
		}
	else
		{ *vystup_y=adresy_u[j][0];	/* utok */
		  *vystup_x=adresy_u[j][1];
		  priority_u[j]=0;
		  return;
		}
}

void initbartovic(void)
{ int i,j,r,s;
/* vymazanie pola */
  for (i=0; i<=20; i++)
   for (j=0; j<=20; j++)
		pole[i][j]=0;

/* vymazanie priorit buffra */
  for (i=0; i<8; i++, priority_o[i]=0, priority_u[i]=0); 

/* vymazanie bufra klaves */
  for (i=0; i<10; i++, bufer_klaves[i][0]=0);

/* ohranicenie pola  ***** OK - ja ***** */
  for (i=0; i<=20; i++)
	{ pole[i][0]=WALL;
	  pole[i][20]=WALL;
	  pole[0][i]=WALL;
	  pole[20][i]=WALL;
	}
}

typedef struct {int x,y;} posit;
extern unsigned char a[50][50];
extern int NP;

posit bartovic(int xox, int yoy,unsigned char ja)
{posit rp;
 int i,j,r,s;
 int riadok,stlpec,cas,cas2;
/* hlavny program */
//  while (1)
//	{ 
 	  vyhra=tri_u=tri_o=styri_o=0;

//	  scanf ("%d %d %d %d", &riadok, &stlpec, &cas, &cas2); 

//	  if (cas == 0) exit(0);
          riadok=xox+1;
          stlpec=yoy+1;

	  if (riadok == 0 && stlpec == 0)
		{ riadok=stlpec=5;
		  pole[riadok][stlpec] = OK;
		  poloha_do_bufra += 1;
		  if (poloha_do_bufra > 9) poloha_do_bufra=0;
		  i=poloha_do_bufra;
		  bufer_klaves[i][0]=riadok;
		  bufer_klaves[i][1]=stlpec;
                  rp.x=riadok-1;
                  rp.y=stlpec-1;
                  return rp;
//printf("%d %d\n",riadok,stlpec);
//                  fflush( NULL );
//		  continue;
		}

	  pole[riadok][stlpec] = KO;		/* KO - on */

	  for (i=0; i<8; i++)
		{ r=adresy_o[i][0];
		  s=adresy_o[i][1];
		  if ( pole[r][s] != 0 )
			 priority_o[i]=0;
		  r=adresy_u[i][0];
		  s=adresy_u[i][1];
		  if ( pole[r][s] != 0 )
			 priority_u[i]=0;
		}

	  analyza (riadok, stlpec, &riadok, &stlpec);

	  pole[riadok][stlpec] = OK;
	  poloha_do_bufra += 1;
	  if (poloha_do_bufra > 9) poloha_do_bufra=0;
	  i=poloha_do_bufra;
	  bufer_klaves[i][0]=riadok;
	  bufer_klaves[i][1]=stlpec; 
//	  printf("%d %d\n",riadok,stlpec);
//          fflush( NULL );
          rp.x=riadok-1;
          rp.y=stlpec-1;
          return rp;
	}
//}

